Package com.io7m.smfj.core

## Class SMFAttributeName

- java.lang.Object
- - com.io7m.smfj.core.SMFAttributeName

- All Implemented Interfaces:
    `SMFAttributeNameType`, `java.lang.Comparable<SMFAttributeNameType>`

      public final class SMFAttributeName
      extends java.lang.Object
      implements SMFAttributeNameType

  An attribute name.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `SMFAttributeName.Builder` | Builds instances of type `SMFAttributeName`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static SMFAttributeName.Builder` | `builder()` | Creates a builder for `SMFAttributeName`.
    `static SMFAttributeName` | `copyOf​(SMFAttributeNameType instance)` | Creates an immutable copy of a `SMFAttributeNameType` value.
    `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `SMFAttributeName` that have equal attribute values.
    `int` | `hashCode()` | Computes a hash code from attributes: `value`.
    `static SMFAttributeName` | `of​(java.lang.String value)` | Construct a new immutable `SMFAttributeName` instance.
    `java.lang.String` | `toString()` | Prints the immutable value `SMFAttributeName` with attribute values.
    `java.lang.String` | `value()` |
    `SMFAttributeName` | `withValue​(java.lang.String value)` | Copy the current immutable object by setting a value for the `value` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.smfj.core.SMFAttributeNameType

      `checkPreconditions, compareTo`

- - ### Method Detail

    - #### value

          public java.lang.String value()

      Specified by:
        `value` in interface `SMFAttributeNameType`
      Returns:
        The actual name value

    - #### withValue

          public final SMFAttributeName withValue​(java.lang.String value)

      Copy the current immutable object by setting a value for the `value` attribute. An equals check used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for value
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals​(java.lang.Object another)

      This instance is equal to all instances of `SMFAttributeName` that have equal attribute values.
      Overrides:
        `equals` in class `java.lang.Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `value`.
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        hashCode value

    - #### toString

          public java.lang.String toString()

      Prints the immutable value `SMFAttributeName` with attribute values.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        A string representation of the value

    - #### of

          public static SMFAttributeName of​(java.lang.String value)

      Construct a new immutable `SMFAttributeName` instance.
      Parameters:
        `value` - The value for the `value` attribute
      Returns:
        An immutable SMFAttributeName instance

    - #### copyOf

          public static SMFAttributeName copyOf​(SMFAttributeNameType instance)

      Creates an immutable copy of a `SMFAttributeNameType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable SMFAttributeName instance

    - #### builder

          public static SMFAttributeName.Builder builder()

      Creates a builder for `SMFAttributeName`.

           SMFAttributeName.builder()
              .setValue(String) // required value
              .build();

      Returns:
        A new SMFAttributeName builder